<script setup lang="ts">
  import {
    CmsElementCrossSelling,
    CustomSliderElementConfig,
    useCmsElementConfig,
  } from '@shopware-pwa/composables-next';
  import { getProducts } from '@shopware-pwa/api-client';
  import { CrossSelling, ShopwareSearchParams } from '@shopware-pwa/types';
  import { getTranslatedProperty } from '@shopware-pwa/helpers-next';
  import { CmsActionType } from '~/logic/interfaces';
  import { CmsPageKey, CmsSlotKey } from '~/helpers/injection';

  const props = defineProps<{
    content: CmsElementCrossSelling;
  }>();
  const cmsSlotInject = inject(CmsSlotKey);
  const cmsPageInject = inject(CmsPageKey);
  const { apiInstance } = useShopwareContext();
  const { getConfigValue } = useCmsElementConfig(props.content);
  const crossSellCollections = ref<CrossSelling[]>([]);
  const loading = ref();
  const sliderRefs = ref<any>([]);
  const tabRef = ref<any>();
  const { publishScrollTo, setContainerRef } = useElementInteraction();
  const tabId = `${props.content.customFields?._uniqueIdentifier as string}-tab`;

  onMounted(async () => {
    if (!props.content?.data?.crossSellings) return;
    loading.value = true;
    const fetchProducts = props.content?.data?.crossSellings?.map(async (crossSelling: any) => {
      if (crossSelling.products?.length) {
        return crossSelling.products;
      } else if (crossSelling.streamId) {
        return await getProductsInStream(
          crossSelling.streamId,
          crossSelling.crossSelling.limit > 1 ? crossSelling.crossSelling.limit : 1,
        );
      } else {
        return [];
      }
    });
    const res = await Promise.all(fetchProducts);
    crossSellCollections.value = props.content?.data?.crossSellings.map(
      (crossSelling: CrossSelling, index: number) => ({
        ...crossSelling,
        products: res[index],
      }),
    );
    loading.value = false;
    nextTick(() => {
      setContainerRef(tabId, tabRef.value);
      sliderRefs.value?.forEach((slider: any, index: number) => {
        setContainerRef(buildSliderId(index), slider?.sliderRef);
      });
    });
  });

  const getProductsInStream = async (streamId: string, limit: number) => {
    const streams = await getProducts(
      {
        limit,
        filter: [
          {
            type: 'contains',
            field: 'streamIds',
            value: streamId,
          },
        ],
      } as ShopwareSearchParams,
      apiInstance as any,
    );
    return streams.elements;
  };

  const config = computed<CustomSliderElementConfig>(() => ({
    minHeight: {
      value: '',
      source: 'static',
    },
    verticalAlign: {
      source: 'static',
      value: '',
    },
    navigationArrows: {
      value: 'outside',
      source: 'static',
    },
    // autoSlide: {
    //   value: true,
    //   source: 'static',
    // },
  }));

  const sliderOptions = computed(() => ({
    slidesPerView: 2,
    breakpoints: {
      '768': {
        slidesPerView: 3,
        spaceBetween: 12,
      },
      '1024': {
        slidesPerView: 4,
        spaceBetween: 16,
      },
      '1920': {
        slidesPerView: 5,
        spaceBetween: 16,
      },
    },
  }));

  const displayMode = computed(() => getConfigValue('displayMode'));
  const boxLayout = computed(() => getConfigValue('boxLayout'));
  const tabs = computed(() =>
    crossSellCollections.value.map((collection) =>
      getTranslatedProperty(collection.crossSelling, 'name'),
    ),
  );

  const buildProductId = (productId: string) => {
    return `${cmsSlotInject?.elementId}-${productId}`;
  };

  const buildSliderId = (index: number) => {
    return `${props.content.customFields?._uniqueIdentifier as string}-slider-${index}`;
  };

  const handlePublish = (productId: string, tabIndex: number, slideIndex: number) => {
    publishScrollTo(props.content.customFields?._uniqueIdentifier as string, productId, [
      {
        elementId: tabId,
        type: CmsActionType.TAB,
        tabIndex,
      },
      {
        elementId: buildSliderId(tabIndex),
        type: CmsActionType.SLIDER,
        slideIndex,
      },
    ]);
  };
</script>

<template>
  <div class="cms-element-cross-selling min-h-10 relative">
    <SwLoading v-if="loading" class="text-primary absolute inset-0 bg-white/80 text-3xl" />
    <SwTab v-else ref="tabRef" :tabs="tabs">
      <template
        v-for="(collection, tabIndex) of crossSellCollections"
        :key="collection.crossSelling?.id"
        #[`tab-${tabIndex}`]
      >
        <SwSlider
          v-if="collection.products?.length"
          :ref="
            (el: any) => {
              sliderRefs[tabIndex] = el;
            }
          "
          :config="config"
          :slider-options="sliderOptions"
        >
          <template v-if="cmsPageInject?.type === 'presentation'">
            <SwTarget
              v-for="(product, slideIndex) of collection.products"
              :key="product.id"
              @publish="() => handlePublish(buildProductId(product.id), tabIndex, slideIndex)"
            >
              <CmsProductCard
                class="h-full"
                :data="product"
                :display-mode="displayMode"
                :box-layout="boxLayout"
              />
            </SwTarget>
          </template>
          <template v-else>
            <CmsProductCard
              v-for="product of collection.products"
              :key="product.id"
              class="h-full"
              :data="product"
              :display-mode="displayMode"
              :box-layout="boxLayout"
            />
          </template>
        </SwSlider>
        <div v-else class="h-30 flex items-center justify-center">
          <h6 class="font-bold">{{ $t('product.messages.noProductsFound') }}</h6>
        </div>
      </template>
    </SwTab>
  </div>
</template>
